<?php
	session_start();

	$url = parse_url( isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
    if(!isset( $url['host']) || ($url['host'] != $_SERVER['SERVER_NAME'])) return;
	define('UPLOADER_DIR','../');
	include_once(UPLOADER_DIR.'resources/config.php');
	require_once(UPLOADER_DIR.'fileuploader.class.php');
    if($_SERVER['REQUEST_METHOD'] != 'POST' || empty($_SERVER['HTTP_REFERER'])||
          !preg_match('/'.$_SERVER['HTTP_HOST'].'/', $_SERVER['HTTP_REFERER'])){
  		@header('HTTP/1.1 403 Forbidden');
    	exit('Access forbbiden');
 	}

	// CSRF validation
	if($CSRF_CHECK && (!isset($_SESSION['uploader_password']) || $_SESSION['uploader_password'] != $dictionary['Password'])){
        echo 'Token validation was not successful';
      	return;
    }

	$controlid=FileUploader::GetParam('controlid','post');
	$extensions=FileUploader::GetParam('extensions','post');
	$size=FileUploader::GetParam('size','post');
	$index=FileUploader::GetParam('index','post');
	$folder=FileUploader::GetParam('folder','post');
	$prefix=FileUploader::GetParam('prefix','post');
	$postfix=FileUploader::GetParam('postfix','post');
	$userandomnames=FileUploader::GetParam('userandomnames','post');
	$overwriteFiles=FileUploader::GetParam('overwritefiles','post');
	$useSuffixes=FileUploader::GetParam('usesuffixes','post');

	function file_upload_error_message($error_code) {
		switch ($error_code) {
			case UPLOAD_ERR_INI_SIZE:
				return 'UPLOAD_ERR_INI_SIZE';
			case UPLOAD_ERR_FORM_SIZE:
				return 'UPLOAD_ERR_FORM_SIZE';
			case UPLOAD_ERR_PARTIAL:
				return 'UPLOAD_ERR_PARTIAL';
			case UPLOAD_ERR_NO_FILE:
				return 'UPLOAD_ERR_NO_FILE';
			case UPLOAD_ERR_NO_TMP_DIR:
				return 'UPLOAD_ERR_NO_TMP_DIR';
			case UPLOAD_ERR_CANT_WRITE:
				return 'UPLOAD_ERR_CANT_WRITE';
			case UPLOAD_ERR_EXTENSION:
				return 'UPLOAD_ERR_EXTENSION';
			default:
				return 'UPLOAD_DEFAULT_ERR';
		}
	}


	$result = false;
	$file_result = isset($_FILES['file'.$controlid.'-'.$index]) ? $_FILES['file'.$controlid.'-'.$index] : '';
    $files = array();
	if($index != -1 && count($_FILES) > 0 && !empty($file_result)){
	    if(is_array($file_result))
    		$files = $file_result;
    	else $files[0] = $file_result;
    	$result=true;
    	echo '$'.$controlid.'*'.$index.'*'.$result;
        for($i=0;$i<count($files);$i++)
        {
            $status = 'Error';

			$file_error = isset($files['error'][$i]) ? $files['error'][$i] : '';
			$file_name = isset($files['name'][$i]) ? $files['name'][$i] : '';
			$file_size = isset($files['size'][$i]) ? $files['size'][$i] : '';
			$file_tmp_name = isset($files['tmp_name'][$i]) ? $files['tmp_name'][$i] : '';
			// TODO: WHY IS IT HAPPENING
			if($file_name == '')
				continue;
			if($file_error == 0){
				if(strrpos($file_name,'.')=='')
					$extension = '';
				else $extension = strtolower(substr($file_name,strrpos($file_name,".")+1));
				if(strlen($extensions)<=1 || strchr($extensions, '|'.$extension.'|'))
				{
					$separator = FileUploader::GetFolderSeparator();
					if(strlen($size)==0 || $size >= $file_size)
					{
						if($userandomnames == 0)
						{
					   		if(strrpos($file_name,'.') == '')
					   			$file_name=$prefix.$file_name.$postfix;
					   		else $file_name=$prefix.substr($file_name,0,strrpos($file_name,'.')).$postfix;
						}
						else $file_name=$prefix.md5(microtime().rand()).$postfix;
						if (file_exists('..'.$separator.$folder.$separator.$file_name.'.'.$extension) && $useSuffixes==0 && $overwriteFiles==0)
						{
	                       $statusText = 'AlreadyExists_Message';
						}
						else
						{
							if(file_exists('..'.$separator.$folder.$separator.$file_name.'.'.$extension) && $useSuffixes==1)
							{
								$j=0;
								do
								{
									$j++;
								}
								while (file_exists('..'.$separator.$folder.$separator.$file_name.'{'.$j.'}'.'.'.$extension));
								$file_name = $file_name.'{'.$j.'}';
							}
							$file_name = $file_name.'.'.$extension;
							if(move_uploaded_file($file_tmp_name,'..'.$separator.$folder.$separator.$file_name))
							{
								$statusText = 'UploadSuccess_Message';
								$status = 'Success';
							}
							else $statusText = "MovingFailed_Message";
						}
					}
					else $statusText = 'TooBig_Message';
				}
				else $statusText = 'BadExtension_Message';
			}else{
				$statusText = file_upload_error_message($file_error);
			}
			echo '$'.$file_name.'*'.$status.'*'.$file_size.'*'.$statusText;
		}
	}
	else{
		echo '$'.$controlid.'*'.$index.'*0$***NoReportedFile_Message';
	}
	echo '$';
